﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=6.8
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Private fx As JFX
End Sub

Sub summarizeCat(fld As field)
	Dim Frequencies As List: Frequencies.initialize
	Dim ValidN As Int = 0
	Dim Outliers As List: Outliers.initialize
	
	Dim freq As Map: freq.initialize
	For Each s As String In fld.Data
		If s.Length>0 Then
			If freq.containsKey(s) Then
				freq.Put(s, freq.Get(s) + 1)
			Else
				freq.Put(s, 1)
			End If
			ValidN = ValidN + 1
		End If
	Next
	Dim sorted As List: sorted.initialize
	For Each s As String In freq.Keys
		Dim n As Float = freq.Get(s)
		If (n / ValidN) < .01 Then  Outliers.Add(s)
		sorted.Add(s)
	Next
	Outliers.Sort(True)
	
	sorted.Sort(True)
	For Each s As String In sorted
		Dim fp As freqPair: fp.initialize
		fp.val = s
		fp.num = freq.Get(s)
		Frequencies.Add(fp)
	Next
	
	fld.Frequencies = Frequencies
	fld.ValidN = ValidN
	fld.Outliers = Outliers
End Sub

Sub summarizeNum(fld As field)
	Dim Frequencies As List: Frequencies.initialize
	Dim ValidN As Int = 0
	Dim Outliers As List: Outliers.initialize
	Dim MinX As Float = 9999999E10
	Dim MaxX As Float = -9999999E10
	Dim sum As Float = 0.0
	Dim sumsq As Float = 0.0
	Dim freq As Map: freq.initialize
	For Each s As String In fld.Data
		If s.Length>0 Then
			Dim sf As Float = s
			sum = sum + sf
			sumsq = sumsq + sf * sf
			If sf < MinX Then MinX = sf
			If sf > MaxX Then MaxX = sf
			s = NumberFormat2(sf, 1, 2, 2, False)
			If freq.containsKey(s) Then
				freq.Put(s, freq.Get(s) + 1)
			Else
				freq.Put(s, 1)
			End If
			ValidN = ValidN + 1
		End If
	Next
	Dim sorted As List: sorted.initialize
	For Each s As String In freq.Keys
		Dim p As sortPair: p.initialize
		p.flt = s
		p.str = s
		sorted.Add(p)
	Next
	Outliers.Sort(True)
	
	sorted.SortType("flt", True)
	Dim cumprop As Float = 0.0
	Dim nfl As Float = ValidN
	For Each p As sortPair In sorted
		Dim strVal As String = p.str
		Dim fp As freqPair: fp.initialize
		fp.val = strVal
		fp.num = freq.Get(strVal)
		Frequencies.Add(fp)
		Dim prop As Float = fp.num / nfl
		cumprop = cumprop + prop
		If prop<.01 And ((cumprop < .01) Or (cumprop > .99)) Then Outliers.Add(fp.val)
	Next
	
	If Frequencies.size = fld.Data.Size Then Frequencies.Clear
	
	fld.Frequencies = Frequencies
	fld.ValidN = ValidN
	fld.Outliers = Outliers
	
	Dim n, a1, a2 As Double
	If ValidN> 0 Then
		n  = ValidN
		fld.Mean = sum / n
		If ValidN>1 Then
			a1 = n * sumsq - (sum) * (sum)
			a2 = n * (n-1)
			fld.SD = Sqrt(a1/a2)
			fld.SEM = fld.SD/Sqrt(n)
		End If
	End If
	
	fld.MinX = MinX
	fld.MaxX = MaxX
End Sub

Sub pearsonCorr(x1 As field, x2 As field)
	Dim x1f, x2f, nsum, x1sum, x1sumsq, x1mean, x2sum, x2sumsq, x2mean, x1x2sum As Double
	nsum = 0: x1sum = 0: x2sum = 0
	For i = 0 To Main.dataSize - 1
		Dim selectIt As Boolean = Main.theFilter.get(i)
		If selectIt  = False Then Continue
		Dim x1d As String = x1.data.Get(i)
		Dim x2d As String = x2.data.Get(i)
		If x1d.Length>0 And x2d.Length>0 Then
			nsum = nsum + 1
			x1f = x1d: x1sum = x1sum + x1f
			x2f = x2d: x2sum = x2sum + x2f
		End If
	Next
	Dim dt As Long = DateTime.Now
	Dim dtx As String = DateTime.Date(dt) & " " & DateTime.Time(dt)
	If nsum<2 Then
		toWB.addTitle(x1.Name & " x " & x2.Name & "   -   Pearson R [too few cases to compute]      [" &  dtx & "]", 2)
		Return
	End If
	
	toWB.addTitle(x1.Name & " x " & x2.Name & "   -   Pearson R      [" & dtx & "]", 2)
	
	x1mean = x1sum / nsum
	x2mean = x2sum / nsum
	
	x1sumsq = 0: x2sumsq = 0: x1x2sum = 0
	For i = 0 To Main.dataSize - 1
		Dim selectIt As Boolean = Main.theFilter.get(i)
		If selectIt  = False Then Continue
		Dim x1d As String = x1.data.Get(i)
		Dim x2d As String = x2.data.Get(i)
		If x1d.Length>0 And x2d.Length>0 Then
			x1f = x1d - x1mean: x1sumsq = x1sumsq + x1f * x1f
			x2f = x2d - x2mean: x2sumsq = x2sumsq + x2f * x2f
			x1x2sum = x1x2sum + x1f * x2f
		End If
	Next
	
	Dim pearsonR As Double = x1x2sum / Sqrt(x1sumsq * x2sumsq)
	
	If x1sumsq = 0 Then
		toWB.addSubTitle(x1.Name & " is a constant - correlations are not defined", 2)
		Main.track(2) = Main.track(2) + 1
		Return
	Else if x2sumsq = 0 Then
		toWB.addSubTitle(x2.Name & " is a constant - correlations are not defined", 2)
		Main.track(2) = Main.track(2) + 1
		Return
	End If
	
	Dim df As Int = nsum - 2
	Dim rlower As Double = tanh(atanh(pearsonR) - 1.96 / Sqrt(df - 1))
	Dim rupper As Double = tanh(atanh(pearsonR) + 1.96 / Sqrt(df - 1))
	
	Dim rstatx As String = NumberFormat2(pearsonR, 1, 4, 4, False)
	
	
	Dim plevx As String = NumberFormat2((1-cdfR(pearsonR, df)), 1, 4, 4, False)
	Dim rlowerx As String = NumberFormat2(rlower, 1, 4, 4, False)
	Dim rupperx As String = NumberFormat2(rupper, 1, 4, 4, False)
	toWB.addSubtitle("Correlation (" & df & ") = " & rstatx & "  [p = " & plevx & ", two-tailed]  95% confidence interval " & rlowerx & " to " & rupperx, 2)
	Main.track(2) = Main.track(2) + 1
	Dim x1nam As String = x1.name.tolowercase
	Dim x2nam As String = x1.name.tolowercase
	Dim vf1() As String = Regex.Split("_", x1nam)
	Dim vf2() As String = Regex.Split("_", x2nam)
	If (vf1(0) = vf2(0)) Or (vf1(vf1.Length-1) = vf2(vf2.Length-1)) Or (x1nam.StartsWith("pre") And x2nam.StartsWith("post")) Then 
		Dim sumdif As Double = 0
		Dim sumdifsq As Double = 0
		For i = 0 To Main.dataSize - 1
			Dim selectIt As Boolean = Main.theFilter.get(i)
			If selectIt  = False Then Continue
			Dim x1d As String = x1.data.Get(i)
			Dim x2d As String = x2.data.Get(i)
			If x1d.Length>0 And x2d.Length>0 Then
				x1f = x1d: x2f = x2d
				Dim dif As Double = x2f - x1f
				sumdif = sumdif + dif
				sumdifsq = sumdifsq + dif * dif
			End If
		Next
		
		Dim avedif As Double = sumdif / nsum
		Dim sddif As Double = Sqrt((sumdifsq - sumdif * sumdif / nsum) / (nsum - 1))
		Dim sderr As Double = sddif / Sqrt(nsum)
		Dim tval As Double = avedif / sderr
		df = nsum - 1
		Dim dif As Double = x2mean - x1mean
		
		Dim tvx As String = NumberFormat2(tval, 1, 3, 3, False)
		Dim difx As String = NumberFormat2(dif, 1, 3, 3, False)
		plevx = NumberFormat2((1-cdfT(tval, df)), 1,4,4,False)
		toWB.addSubtitle("Difference of Means:  dif = " & difx & "    paired t-Test (" & df & ") = " & tvx & "     [p = " & plevx & ", two tailed]", 2)
		Main.track(2) = Main.track(2) + 1
	End If
End Sub

Sub breakDown(a As field, b As field)
	Dim dt As Long = DateTime.Now
	Dim dtx As String = DateTime.Date(dt) & " " & DateTime.Time(dt)
	toWB.addTitle(a.Name & " x " & b.Name & "   -   Breakdown      [" & dtx & "]", 2)
	
	Dim freq As List = b.Frequencies
	Dim totalN As Int = 0
	Dim n As Int = freq.size
	Dim nsum(n) As Float
	Dim sum(n) As Float
	Dim sumsq(n) As Float
	Dim minx(n) As Float
	Dim maxx(n) As Float
	For j = 0 To n - 1
		nsum(j) = 0
		sum(j) = 0
		sumsq(j) = 0
		minx(j) = 9999999E10
		maxx(j) = -9999999E10
	Next
	
	For i = 0 To Main.dataSize - 1
		Dim selectIt As Boolean = Main.theFilter.get(i)
		If selectIt  = False Then Continue
		Dim grp As String =  b.data.Get(i)
		Dim dat As String = a.data.Get(i)
		If grp.Length>0 And dat.Length>0 Then
			For j = 0 To n - 1
				Dim fp As freqPair = freq.Get(j)
				Dim group As String = fp.val
				Dim inGroup As Boolean = False
				If b.Numeric Then
					Dim fgroup As Float = group
					Dim fgrp As Float = grp
					If Abs(fgrp-fgroup)<.0001 Then inGroup = True
				Else
					If grp = group Then inGroup = True
				End If
				If inGroup Then
					Dim datx As Float = dat
					totalN = totalN + 1
					nsum(j) = nsum(j) + 1
					sum(j) = sum(j) + datx
					sumsq(j) = sumsq(j) + datx * datx
					If datx < minx(j) Then minx(j) = datx
					If datx > maxx(j) Then maxx(j) = datx
				End If
			Next
		End If
	Next


	toWB.addColumns("^"& TAB & TAB & TAB & "^" & a.Name, 2)
	toWB.addColumns("^" & b.name  & TAB & "^n" & TAB & "^Mean" & TAB & "^SD" & TAB & "^SEM" & TAB & "^Min" & TAB & "^Max", 2)
	
	Dim numTotal As Double = 0
	Dim sumTotal As Double = 0
	Dim wterms As Double = 0
	Dim bterms As Double = 0
	Dim saveMean(n) As Float

	For j = 0 To n - 1
		Dim fp As freqPair = freq.Get(j)
		Dim group As String = fp.val
		If b.Numeric Then group = "'" & group & "'"
		Dim meanx, sdx, semx As Float
		Dim meanz, sdz, semz As String
		meanz = "^": sdz = "^": semz = "^"
		If nsum(j) > 0  Then
			meanx = sum(j) / nsum(j)
			meanz = NumberFormat2(meanx, 1, 4, 4, False)
			saveMean(j) = meanx
		End If
		If nsum(j) > 1 Then
			Dim a1 As Float = nsum(j) * sumsq(j) - (sum(j)) * (sum(j))
			Dim a2 As Float = nsum(j) * (nsum(j)-1)
			sdx = Sqrt(a1/a2)
			semx = sdx/Sqrt(n)
			sdz = NumberFormat2(sdx, 1, 4, 4, False)
			semz = NumberFormat2(semx, 1, 4, 4, False)
			numTotal = numTotal + nsum(j)
			sumTotal = sumTotal + sum(j)
			wterms = wterms + (nsum(j) - 1) * sdx * sdx
		End If
		Dim minxz As String = NumberFormat2(minx(j), 1, 4, 4, False)
		Dim maxxz As String = NumberFormat2(maxx(j), 1, 4, 4, False)
		If nsum(j) = 0 Then 
			minxz = "^"
			maxxz = "^"
		End If
		toWB.addColumns("^" & group & TAB & nsum(j) & TAB & meanz & TAB & sdz & TAB & semz & TAB & minxz & TAB & maxxz, 2)
	Next
	Main.track(2)  = Main.track(2) + 1
	
	For j = 0 To n-1
		If nsum (j) < 2 Then
			toWB.addSubtitle("One or more 'n's are less then 2.  F-Statistic can not be computed.", 2)
			Main.track(2)  = Main.track(2) + 1
			Return
		Else if Abs(sdx) < .000001 Then
			toWB.addSubtitle("One or more items have zero variance.  F-Statistic can not be computed.", 2)
			Main.track(2)  = Main.track(2) + 1
			Return
		End If
	Next
	
	If numTotal<= n Then
		toWB.addSubtitle("Too few cases.  F-Statistic can not be computed.", 2)
		Main.track(2)  = Main.track(2) + 1
		Return
	End If
	
	Dim grandMean As Double = sumTotal/numTotal
	For j = 0 To n - 1
		bterms = bterms + nsum(j) * (saveMean(j) - grandMean) * (saveMean(j) - grandMean)
	Next

	Dim dfbetween As Double = n - 1
	Dim dfwithin As Double = numTotal - n
	Dim msWithin As Double = wterms / dfwithin
	Dim msBetween As Double = bterms / dfbetween
	Dim fvalue As Float = msBetween / msWithin

	Dim dfVector() As Int = Array As Int(0, 0)
	dfVector(0) = dfwithin
	dfVector(1) = dfbetween
	Dim FStat As String = NumberFormat2(fvalue, 1, 4, 4, False)
	Dim plevx As String = NumberFormat2((1-cdfF(fvalue, dfbetween, dfwithin)), 1,4,4,False)
	toWB.addSubtitle("ANOVA F (" & dfbetween & "," & dfwithin & ") = " & FStat & "  [p = " & plevx & ", right-tailed]", 2)
	If dfbetween = 1 Then
		toWB.addSubtitle("t-value(" & dfwithin & ") for comparing two means is SqRoot(F) = " & NumberFormat2(Sqrt(FStat), 1, 4, 4, False) & " and p value is the same As above.", 2)
	End If
	Main.track(2)  = Main.track(2) + 1
End Sub

Sub crossTab(a As field, b As field)
	Dim dt As Long = DateTime.Now
	Dim dtx As String = DateTime.Date(dt) & " " & DateTime.Time(dt)
	toWB.addTitle(a.Name & " x " & b.Name & "   -   Crosstab      [" & dtx & "]", 2)
	
	Dim pairMap As Map: pairMap.initialize
	For i = 0 To Main.dataSize - 1
		Dim selectIt As Boolean = Main.theFilter.get(i)
		If selectIt  = False Then Continue
		Dim grpb As String =  b.data.Get(i)
		Dim grpa As String = a.data.Get(i)
		
		If grpa.Length>0 And grpb.Length>0 Then
			Dim df As Float
			If a.Numeric Then
				df = grpa
				grpa = NumberFormat2(df, 1, 2, 2, False)
			End If
			If b.Numeric Then
				df = grpb
				grpb = NumberFormat2(df, 1, 2, 2, False)
			End If
			Dim pairVal As String = grpa & TAB & grpb
			If pairMap.ContainsKey(pairVal) Then
				pairMap.Put(pairVal, pairMap.Get(pairVal) + 1)
			Else
				pairMap.Put(pairVal, 1)
			End If
		End If
	Next
	
	Dim sb As StringBuilder: sb.initialize
	sb.append(TAB)
	For m = 0 To 1
		For k = 1 To b.Frequencies.Size + 3
			sb.Append(TAB)
		Next
		If m = 0 Then
			sb.append("^% of row totals")
		Else
			sb.append("^% of column totals")
		End If
	Next
	toWB.addColumns(sb.toString, 2)
	
	sb.Initialize
	sb.append(TAB)
	sb.append(TAB)
	For m = 0 To 1
		sb.append("^" & b.name)
		For k = 1 To b.Frequencies.Size + 3
			sb.Append(TAB)
		Next
	Next
	sb.append("^" & b.name)
	toWB.addColumns(sb.toString, 2)
	
	sb.Initialize
	For m = 0 To 2
		sb.Append("^" & a.name)
		For k = 0 To b.Frequencies.Size - 1
			Dim fp As freqPair = b.Frequencies.get(k)
			Dim itemnam As String = fp.val
			If b.Numeric Then itemnam = "'" & itemnam & "'"
			sb.Append(TAB & "^" & itemnam)
		Next
		sb.append(TAB & "^total")
		sb.append(TAB)
		sb.append(TAB)
	Next
	toWB.addColumns(sb.toString, 2)
	Main.track(2) = Main.track(2) + 1
	Dim nrows As Int = a.Frequencies.Size
	Dim ncols As Int = b.Frequencies.Size
	Dim matrix(nrows, ncols) As Float
	Dim colTotals(ncols) As Int
	For j = 0 To ncols-1
		colTotals(j) = 0
	Next
	
	Dim ki As Int = -1
	For Each aItem As freqPair In a.Frequencies
		ki = ki + 1
		Dim kj As Int = -1
		For Each bItem As freqPair In b.Frequencies
			kj = kj + 1
			Dim pairVal As String  = aItem.val & TAB & bItem.val
			Dim np As Int = 0
			If pairMap.ContainsKey(pairVal) Then np = pairMap.Get(pairVal)
			matrix(ki, kj) = np
			colTotals(kj) = colTotals(kj) + np
		Next
	Next

	Dim Total As Int = 0
	For j = 0 To ncols-1
		Total = Total + colTotals(j)
	Next
	
	For Each aItem As freqPair In a.Frequencies
		sb.Initialize
		Dim itemnam As String = aItem.val
		If a.Numeric Then itemnam = "'" & itemnam & "'"
		sb.append("^" & itemnam)
		Dim rowTotal As Int = 0
		For Each bItem As freqPair In b.Frequencies
			Dim pairVal As String  = aItem.val & TAB & bItem.val
			Dim np As Int = 0
			If pairMap.ContainsKey(pairVal) Then np = pairMap.Get(pairVal)
			rowTotal = rowTotal + np
			sb.Append(TAB & np)
		Next
		sb.Append(TAB & rowTotal)
		sb.Append(TAB)
		sb.Append(TAB)
		sb.append("^" & itemnam)
		For Each bItem As freqPair In b.Frequencies
			Dim pairVal As String  = aItem.val & TAB & bItem.val
			Dim np As Int = 0
			If pairMap.ContainsKey(pairVal) Then np = pairMap.Get(pairVal)
			If rowTotal > 0 Then
				Dim perc As Float = 100.0 * np / rowTotal
				Dim percx As String = NumberFormat2(perc, 1, 1, 1, False)
				sb.Append(TAB & percx)
			Else
				sb.Append(TAB)
			End If
		Next
		sb.Append(TAB & "100")
		sb.Append(TAB)
		sb.Append(TAB)
		sb.append("^" & itemnam)
		kj = -1
		For Each bItem As freqPair In b.Frequencies
			kj = kj + 1
			Dim pairVal As String  = aItem.val & TAB & bItem.val
			Dim np As Int = 0
			If pairMap.ContainsKey(pairVal) Then np = pairMap.Get(pairVal)
			If colTotals(kj)>0 Then
				Dim perc As Float = 100.0 * np / colTotals(kj)
				Dim percx As String = NumberFormat2(perc, 1, 1, 1, False)
				sb.Append(TAB & percx)
			Else
				sb.Append(TAB)
			End If
		Next
		Dim tperc As Float = 100.0 * rowTotal / Total
		Dim tpercx As String = NumberFormat2(tperc, 1, 1, 1, False)
		sb.Append(TAB & tpercx)
		toWB.addColumns(sb.ToString, 2)
	Next
	Main.track(2) = Main.track(2) + 1
	sb.Initialize
	sb.append("^total")
	For j = 0 To ncols-1
		sb.Append(TAB & colTotals(j))
	Next
	sb.Append(TAB & Total)
	sb.Append(TAB)
	sb.Append(TAB & "^total")
	For j = 0 To ncols-1
		Dim zperc As Float = 100.0 * colTotals(j) / Total
		Dim zpercx As String = NumberFormat2(zperc, 1, 1, 1, False)
		sb.Append(TAB & zpercx)
	Next
	sb.Append(TAB & "100")
	sb.Append(TAB)
	sb.Append(TAB & "^total")
	For j = 0 To ncols-1
		sb.Append(TAB & "100")
	Next
	sb.Append(TAB & "100")
	toWB.addColumns(sb.ToString, 2)
	Main.track(2) = Main.track(2) + 1

	Dim chisq As Float = computeChi2(matrix, nrows, ncols)
	Dim ndf As Int = (nrows-1)*(ncols-1)
	If chisq<0 Then
		If Total < 100 And (ndf = 1) Then
			toWB.addSubtitle("ChiSquare is not valid (>20% of cells have expected<5)     " & fisher(matrix), 2)
		Else if ndf = 1 Then
			toWB.addSubtitle("ChiSquare is not valid (>20% of cells have expected<5) AND N = " & Total & " is too large For fisher's Exact)", 2)
		Else
			toWB.addSubtitle("ChiSquare is not valid (>20% of cells have expected<5)", 2)
		End If
	Else
		Dim chi2 As String = NumberFormat2(chisq, 1,1,1,False)
		Dim levx As String = NumberFormat2((1-cdfC(chisq, ndf)),1,4,4,False)
		If Total < 100 And (ndf = 1) Then
			toWB.addSubtitle("ChiSquare (" & ndf & ") = " & chi2 & " [p = " & levx & ", right-tailed]    " & fisher(matrix), 2)
		Else
			toWB.addSubtitle("ChiSquare (" & ndf & ") = " & chi2 & " [p = " & levx & ", right-tailed]", 2)
		End If
	End If
	Main.track(2) = Main.track(2) + 1
End Sub

Sub computeChi2(matrix(,) As Float, nrows As Int, ncols As Int) As Float
	Dim rowTotals(nrows) As Float
	Dim colTotals(ncols) As Float
	Dim ntotal As Float = 0
	For i = 0 To nrows-1
		Dim sum As Float = 0
		For j = 0 To ncols - 1
			sum = sum + matrix(i,j)
			ntotal = ntotal + matrix(i,j)
		Next
		rowTotals(i) = sum
	Next
	For j = 0 To ncols-1
		Dim sum As Float = 0
		For i = 0 To nrows - 1
			sum = sum + matrix(i,j)
		Next
		colTotals(j) = sum
	Next
	Dim chisq As Float = 0
	Dim nlowExp As Int = 0
	Dim yates As Float  = 0
	If nrows = 2 And ncols = 2 Then yates = .5
	For i = 0 To nrows-1
		For j = 0 To ncols - 1
			Dim expect As Float = rowTotals(i) * colTotals(j) / ntotal
			If expect < 5 Then nlowExp = nlowExp + 1
			Dim term As Float = Abs((matrix(i,j) - expect)-yates)
			chisq = chisq + term * term
		Next
	Next
	If nlowExp/(nrows*ncols) > .2 Then chisq = - chisq
	Return chisq
End Sub

Sub swap(m(,) As Int, i1 As Int, j1 As Int, i2 As Int, j2 As Int)
	Dim temp As Int = m(i1,j1)
	m(i1,j1) = m(i2,j2)
	m(i2,j2) = temp
End Sub

Sub fisher(mf(,) As Float) As String
	Dim m(3,3) As Int
	m(1,1) = mf(0,0)
	m(1,2) = mf(0,1)
	m(2,1) = mf(1,0)
	m(2,2) = mf(1,1)
	'The algorithm is easier with an integer matrix and an index base of 1
	Dim Minx As Int = 9999
	If m(1, 1) < Minx Then Minx = m(1, 1)
	If m(1, 2) < Minx Then Minx = m(1, 2)
	If m(2, 1) < Minx Then Minx = m(2, 1)
	If m(2, 2) < Minx Then Minx = m(2, 2)
	Select Case Minx
		Case m(2, 1)
			swap (m, 2, 1, 1, 1)
			swap (m, 2, 2, 1, 2)
		Case m(1, 2)
			swap (m, 1, 2, 1, 1)
			swap (m, 2, 2, 2, 1)
		Case m(2, 2)
			swap (m, 2, 1, 1, 1)
			swap (m, 2, 2, 1, 2)
			swap (m, 1, 2, 1, 1)
			swap (m, 2, 2, 2, 1)
	End Select
	
	Dim v(500) As Double
	Dim i As Int = 0
	For a = 1 To m(1, 1)
		i = i + 1
		v(i) = m(1, 2) + a
	Next
	For b = 1 To m(1, 2)
		i = i + 1
		v(i) = m(2, 2) + b
	Next
	For c = 1 To m(2, 1)
		i = i + 1
		v(i) = m(1, 1) + c
	Next
	For d = 1 To m(2, 2)
		i = i + 1
		v(i) = m(2, 1) + d
	Next
	If i Mod 2 = 1 Then
		i = i + 1
		v(i) = i
	End If

	Dim productTerm As Double = 1
	For k = 1 To i Step 2
		Dim kd As Double = k * (i - k + 1)
		productTerm = productTerm * v(k) * (v(k + 1) / kd)
	Next

	Dim saveProduct As Double = productTerm
	Dim fisherProb As Double = productTerm

	Do While m(1, 1) > 0
		m(1, 2) = m(1, 2) + 1
		m(2, 1) = m(2, 1) + 1
		Dim g11 As Double = m(1, 1)
		Dim g22 As Double = m(2, 2)
		Dim g12 As Double = m(1, 2)
		Dim g21 As Double = m(2, 1)
		productTerm = productTerm * ((g11 * g22) / (g12 * g21))
		If productTerm < .000001 Then Exit
		fisherProb = fisherProb + productTerm
		m(1, 1) = m(1, 1) - 1
		m(2, 2) = m(2, 2) - 1
	Loop

	Dim suf As String = ""
	Dim tochers As Boolean = False
	If fisherProb >= .05 Then
		Dim extrap As Double = (fisherProb - saveProduct)
		If extrap < .05 Then
			Dim tocher As Double = (.05 - extrap) / saveProduct
			If (Rnd (0, 100)/100 < tocher) Then tochers = True
			suf = " Tocher's " & tochers
		End If
	End If
	
	Dim r As String = "Fisher's Exact p = " & NumberFormat2(fisherProb, 1, 4, 4, False) & suf
	Return r
End Sub

Sub multiIndependent(var As List)
	Dim numericVar As List: numericVar.initialize
	For Each fldnum As Int In var
		Dim fld As field = Main.fields.Get(fldnum)
		If fld.Numeric Then numericVar.Add(fldnum)
	Next
	
	If Main.track(3) < 0 Then toWB.addCitation
	
	Dim sbMonitor As StringBuilder: sbMonitor.initialize
	For Each k As Int In var
		Dim fld As field = Main.fields.Get(k)
		sbMonitor.Append(fld.name & CRLF)
		Main.monitor.Text = sbMonitor.toString
		Main.monitor.SetSelection(Main.monitor.Text.Length, Main.monitor.Text.Length)
		Sleep(200)
	Next

	Dim rs1 As ResumableSub = invokeR("reliability", 0, var)
	Wait For(rs1) Complete (Result As Object)
	
	Dim rs2 As ResumableSub = invokeR("principal", 0, var)
	Wait For(rs2) Complete (Result As Object)
	
	CallSubDelayed(Main, "multivarTask_Complete")
End Sub


Sub multivariate
	Main.infoLabel.Text = "Computing Multivariate Statistics"
	
	Dim depList As List: depList.initialize
	For Each ki As Int In Main.leftIndices
		Dim fldi As field = Main.fields.Get(ki)
		If fldi.Numeric And fldi.ValidN > 1 Then
			depList.Add(ki)
		End If
	Next
	If depList.Size = 0 Then
		CallSubDelayed(Main, "multivarTask_Complete")
		Return
	End If
	
	Dim indepList As List: indepList.initialize
	For Each kj As Int In Main.rightIndices
		Dim fldj As field = Main.fields.Get(kj)
		If fldj.Numeric And fldj.ValidN > 1 Then
			indepList.Add(kj)
		End If
	Next
	If indepList.Size = 0 Then
		CallSubDelayed(Main, "multivarTask_Complete")
		Return
	End If
	
	Dim sbMonitor As StringBuilder: sbMonitor.initialize
	For Each ki As Int In depList
		Dim fldi As field = Main.fields.Get(ki)
		sbMonitor.Append(fldi.name & CRLF)
		For Each kj As Int In indepList
			Dim fldj As field = Main.fields.Get(kj)
			sbMonitor.Append(TAB & fldj.name & CRLF)
		Next
		sbMonitor.Append(CRLF)
		Main.monitor.Text = sbMonitor.toString
		Main.monitor.SetSelection(Main.monitor.Text.Length, Main.monitor.Text.Length)
		Sleep(200)
		
		Dim rs3 As ResumableSub = invokeR("regression", ki, indepList)
		Wait For(rs3) Complete (Result As Object)
	Next
	
	CallSubDelayed(Main, "multivarTask_Complete")
End Sub

Sub invokeR(analysis As String, dep As Int, indepList As List) As ResumableSub
	If indepList.IsInitialized = False Then indepList.initialize
	
	Dim fld As field = Main.fields.Get(dep)
	Dim tnames As List: tnames.initialize
	Dim dset As StringBuilder: dset.initialize
	
	Dim vstart As Int = 1
	If analysis = "regression" Then
		dset.Append("v10001" & ",")
		tnames.Add("v10001")
		vstart = 2
		Dim temp As List: temp.Initialize
		'remove dep from indepList
		For Each inx As Int In indepList
			If inx<>dep Then temp.Add(inx)
		Next
		indepList = temp
	End If
	
	For j = 0 To indepList.Size-1
		Dim tname As String = "v" & (10000 + j + vstart)
		tnames.Add(tname)
		dset.Append(tname & ",")
	Next
	dset.Remove(dset.Length-1, dset.Length)
	
	If Main.rdataWritten = False Then
		Main.casesRef.initialize
		Main.rdata.initialize
		Main.rdata.Add(dset.ToString)
		
		For i = 0 To Main.dataSize - 1
			Dim selectIt As Boolean = Main.theFilter.get(i)
			If selectIt  = False Then Continue
			Dim d0 As String = "*"
			If analysis = "regression" Then
				Dim fld0 As field = Main.fields.Get(dep)
				d0  = fld0.data.get(i)
			End If
			If d0.Length>0 Then
				Dim skipRecord As Boolean = False
				dset.initialize
				If analysis = "regression" Then dset.Append(d0 & ",")
				For Each var As Int In indepList
					Dim fld As field = Main.fields.Get(var)
					Dim d As String = fld.data.get(i)
					If d.Length=0 Then
						skipRecord = True
						Exit
					End If
					dset.append(d & ",")
				Next
				If skipRecord = False Then
					dset.Remove(dset.Length-1, dset.Length)
					Main.rdata.Add(dset.ToString)
					Main.casesRef.Add(i)
				End If
			End If
		Next
		File.writelist(Main.RInvokeDir, "RData.txt", Main.rdata)
	End If
	If Main.rdata.Size>2 Then
		Dim script As List: script.initialize
		script.Add($"RD <- read.csv(file="RData.txt", header=TRUE, sep=",", stringsAsFactors = FALSE, quote='"', strip.white = TRUE, na.strings = c("NA",""), dec=".",fill = TRUE,comment.char="",fileEncoding = 'UTF-8-BOM')"$)
		script.Add($"RD <- RD[complete.cases(RD), ]"$)
		If analysis <> "summarize" Then
			script.Add($"attach(RD)"$)
			script.Add($"writeLines(paste(c(nrow(RD)),"Cases"))"$)
		End If
		If analysis ="regression" Then
			Dim formula As StringBuilder: formula.initialize
			formula.append(tnames.Get(0) & " ~ ")
			For j = 1 To tnames.Size-1
				formula.Append(tnames.Get(j) & " + ")
			Next
			formula.Remove(formula.Length-3, formula.Length)
			script.Add($"line <- lm (${formula}, data=RD)"$)
			script.Add($"summary(line)"$)
			script.Add($"q(runLast=FALSE)"$)
		else if analysis = "reliability" Then
			script.Add($"library ("psych")"$)
			script.Add($"alpha(RD)"$)
			script.Add($"q(runLast=FALSE)"$)
		else if analysis = "principal" Then
			script.Add($"prin_comp <- prcomp(RD, center = TRUE, scale. = TRUE)"$)
			script.Add($"prin_comp$rotation"$)
			script.Add($""$)
			script.Add($"summary(prin_comp)"$)
			script.Add($""$)
			script.Add($"prin_comp$x"$)
			script.Add($"q(runLast=FALSE)"$)
		else if analysis = "summarize" Then
			script.Add($"library ("psych")"$)
			script.Add($"describe(RD)"$)
			script.Add($"q(runLast=FALSE)"$)
		else if analysis = "breakdown" Then
			script.Add($"library ("psych")"$)
			script.Add($"describeBy(RD, group=v10002,mat=FALSE,type=3,digits=15)"$)
			script.Add($"q(runLast=FALSE)"$)
		End If
		File.writelist(Main.RInvokeDir, "RMyScript.R", script)
		
		Main.shl.Initialize("shl", Main.RPath, Array As String("CMD", "BATCH", "--slave", "--vanilla", "RMyScript.R"))
		Main.shl.WorkingDirectory = Main.RInvokeDir
		Main.shl.Run(10000) 'set a timeout of 10 seconds
		
		wait for shl_ProcessCompleted (Success As Boolean, ExitCode As Int, StdOut As String, StdErr As String)
		If Success Then
			utils.postEditROutput(analysis, dep, indepList, tnames)
			Main.leftList.Items.clear
			Main.rightList.Items.clear
			For j = 0 To Main.numFields-1
				Dim fld As field = Main.fields.get(j)
				Dim s As String = fld.Name
				Main.leftList.Items.Add(s)
				Main.rightList.Items.Add(s)
			Next
		Else
			CallSub2(Main, "exitOnError", "There was a problem invoking 'R'")
		End If
	End If
	Return Null
End Sub

Sub tanh(x As Float) As Float
	Dim term As Double = Power(cE, -2*x)
	Return (1-term)/(1+term)
End Sub

Sub atanh(x As Float) As Float
	If Abs(x)<1 Then
		Dim term As Double = (1 + x)/(1 - x)
		Return .5*Logarithm(term, cE)
	Else
		Return 0
	End If
End Sub

Sub cdfZ(x As Double) As Double
	If x>=0 Then Return (gammaNormal(.5, x * x / 2)) Else Return (1 - cdfZ(-x))
End Sub

Sub cdfC(x As Double, v As Double) As Double
	If x>=0 Then Return (gammaNormal(.5 * v, x / 2)) Else Return (1 - cdfC(-x, v))
End Sub

Sub cdfT(x As Double, v As Double) As Double
	If x>=0 Then Return (1 - betaNormal(v / 2, .5, v / (v + x*x))) Else Return (1 - cdfT(-x, v))
End Sub

Sub cdfF(x As Double, v1 As Double, v2 As Double) As Double
	If x>=0 Then Return (1 - betaNormal(v2 / 2, v1 / 2, v2 / (v2 + v1*x))) Else Return (1 - cdfF(-x, v1, v2))
End Sub

Sub cdfR(x As Double, v As Double) As Double
	If x>=0 Then Return cdfT(x * Sqrt(v)/Sqrt(1.0 - x*x), v) Else Return cdfR(-x, v)
End Sub

Sub gammaNormal(a As Double, x As Double) As Double
	Dim sum, delta, aStep, result As Double
	result = 0.0
	If (x = 0.0) Then
		result = .5
	Else
		aStep = a: delta = 1.0 / a
		sum = delta
		Dim n As Int = 0
		Do While (Abs(delta) > Abs(sum) * .0000001)
			n = n + 1
			If n>100 Then Return 0.0
			aStep = aStep + 1
			delta = delta * x / aStep
			sum = sum + delta
		Loop
		result = sum * Power(cE, -x + a * Logarithm(x,cE) - logGamma(a))
	End If
	Return result
End Sub

Sub betaNormal(a As Double, b As Double, x As Double) As Double
	If (x < 0.0 Or x > 1.0) Then Return 0.0
	Dim result As Double
	If (x = 0.0 Or x = 1.0) Then
		result = 0.0
	Else
		result = Power(cE, logGamma(a + b) - logGamma(a) - logGamma(b) + a * Logarithm(x, cE) + b * Logarithm(1.0 - x, cE))
	End If
	If (x < (a + 1.0)/(a + b + 2.0)) Then
		result = result * continuousFractions(a, b, x) / a
	Else
		result =  1.0 - result * continuousFractions(b, a, 1.0-x) / b
	End If
	Return result
End Sub

Sub continuousFractions(a As Double, b As Double, x As Double) As Double
	Dim m, m2 As Int
	Dim aa, c, d, delta, result As Double
	c = 1.0
	d = 1.0 / Abs(1.0 - (a +  b) * x / (a + 1))
	result = d
	m = 0: m2 = 0
	Do While Abs(delta-1.0) > .0000001
		m = m + 1
		If m>100 Then Return 0.0
		m2 = m2 + 2
		aa = m * (b - m) * x / ((a + m2) * (a - 1 + m2))
		c = (1.0 + aa/c)
		d = 1.0 / (1.0 + aa*d)
		result = result * c * d
		'alternating two different fractional terms
		aa = -(a + m) * (a + b + m) * x / ((a + m2) * (a + 1 + m2))
		c = (1.0 + aa/c)
		d = 1.0 / (1.0 + aa*d)
		delta = c * d
		result = result * delta
	Loop
	Return result
End Sub

Sub logGamma(z As Double) As Double
	Dim  zStep, denominator, series, Lanczos() As Double   'Lanzos coefficients g=5 n=7
	Lanczos = Array As Double( 1.000000000190015, _
		76.18009172947146, -86.50532032941677, 24.01409824083091, _
		-1.231739572450155, 0.1208650973866179e-2, -0.5395239384953e-5)
	denominator = (z + 5.5) - (z + 0.5) * Logarithm((z + 5.5), cE)
	series = Lanczos(0)
	zStep = z
	For j = 1 To 6
		zStep = zStep + 1
		series = series + Lanczos(j) / zStep
	Next
	Return Logarithm(Sqrt(2*cPI) * series / z, cE) - denominator
End Sub

Sub bivariate
	Main.leftList.Visible = False
	Main.rightList.Visible = False
	Main.infoArea.Visible = False
	Main.monitor.text = ""
	Main.monitor.Visible = True
	Main.infoLabel.Text = "Computing Bivariate Statistics"
	Dim sbMonitor As StringBuilder: sbMonitor.initialize
	For Each ki As Int In Main.leftIndices
		Dim fldi As field = Main.fields.Get(ki)
		For Each kj As Int In Main.rightIndices
			If ki <> kj Then
				Dim done As String = alreadyDone(ki, kj)
				Dim fldj As field = Main.fields.Get(kj)
				If Main.filterVariable > -1 Then
					done = ""
					toWB.addTitle("The following analysis was based on a data subset: " & Main.filterBy , 2)
					Main.track(2) = Main.track(2) + 1
				End If
				If done = "" Then
					If fldi.Frequencies.Size = 0 Or fldj.Frequencies.Size = 0 Then Exit
					If fldj.Frequencies.Size > fldi.Frequencies.Size Then
						fldi = Main.fields.Get(kj)
						fldj = Main.fields.Get(ki)
					End If
					sbMonitor.Append(fldi.name & " x " & fldj.Name & CRLF)
					Main.monitor.Text = sbMonitor.toString
					Main.monitor.SetSelection(Main.monitor.Text.Length, Main.monitor.Text.Length)
					Sleep(200)
					If fldi.Numeric And fldj.Numeric Then
						pearsonCorr(fldi, fldj)
						If fldj.Frequencies.Size < 101 Then
							breakDown(fldi, fldj)
							If fldi.Frequencies.Size < 21 Then
								crossTab(fldi, fldj)
							End If
						Else
							toWB.errorNote(fldi, fldj)
						End If
					End If
					
					If fldi.Numeric And fldj.Numeric = False Then
						If fldj.Frequencies.Size < 101 Then
							breakDown(fldi, fldj)
							If fldi.Frequencies.Size < 21 Then
								crossTab(fldi, fldj)
							End If
						Else
							toWB.errorNote(fldi, fldj)
						End If
					End If
				
					If fldj.Numeric And fldi.Numeric = False Then
						If fldi.Frequencies.Size < 101 Then
							breakDown(fldj, fldi)
							If fldj.Frequencies.Size < 21 Then
								crossTab(fldj, fldi)
							End If
						Else
							toWB.errorNote(fldj, fldi)
						End If
					End If

					If fldi.Numeric = False And fldj.Numeric = False Then
						If fldj.Frequencies.Size < 101 Then
							crossTab(fldi, fldj)
						Else
							toWB.errorNote(fldi, fldj)
						End If
					End If
				Else
					If done.IndexOf("note") = -1 Then
						toWB.addTitle("Note: For '" & fldi.Name & " x " & fldj.Name & "' see row " & done, 2)
						Main.track(2) = Main.track(2) + 1
					End If
				End If
			End If
		Next
	Next
	CallSubDelayed(Main, "bivarTask_Complete")
End Sub

Sub alreadyDone(ki As Int, kj As Int) As String
	Dim sheetNum As Int = 2
	Dim fldi As field = Main.fields.Get(ki)
	Dim fldj As field = Main.fields.Get(kj)
	Dim iName As String = fldi.Name
	Dim jName As String = fldj.name
	Dim note As String = ""
	Dim where As String = ""
	For k = 0 To Main.sheet(sheetNum).LastRowNumber
		Dim row As PoiRow = Main.sheet(sheetNum).GetRow(k)
		If row.IsInitialized Then
			Dim g As PoiCell = row.GetCell(0)
			If g.IsInitialized Then
				Dim s As String = g.value
				If s.Length>0 Then
					Dim fc As String = s.SubString2(0,1)
					If "'0123456789".IndexOf(fc)= -1 Then
						If s.IndexOf(" x ")> - 1 Then
							If s.IndexOf(iName & " ") > -1 And s.IndexOf(jName & " ") > -1 Then
								If s.IndexOf("Note:")> -1 Then
									note = "note"
								Else
									If where = "" Then where = (k + 1)
								End If
							End If
						End If
					End If
				End If
			End If
		End If
	Next
	Return where & note
End Sub

Sub addPercentiles(fld As field, sheetNum As Int)
	Dim items As List = fld.Frequencies
	Dim n As Float = fld.ValidN
	Dim stepSize As Float = n/20
	Dim pr As List: pr.initialize
	
	Dim perct As Int = 0
	Dim normaln As Int = 0
	Dim cumtotal As Long = 0
	Dim lastBin As Int = 0
	Dim temp As List: temp.initialize
	
	toWB.addSubtitle("Percentiles in steps of 5%", sheetNum)
	
	For i = 0 To items.Size-1
		Dim fp As freqPair = items.Get(i)
		cumtotal = cumtotal + fp.num
		Dim whichbin As Int = Floor((cumtotal/stepSize))
		If whichbin >lastBin Then
			For j = lastBin + 1 To whichbin
				perct = j * 5
				pr.Add(perct & TAB & fp.val)
			Next
			lastBin = whichbin
		End If
		temp.Add(fp.val & TAB & fp.num)
		normaln = normaln + fp.num
	Next
	For Each s As String In pr
		toWB.addColumns(s, sheetNum)
	Next
	Main.track(sheetNum) = Main.track(sheetNum) + 1
	Dim ol As List = fld.outliers
	If ol.size>0 Then
		toWB.addColumns("^" & TAB & "^N" & TAB & "^Valid" & TAB & "^Missing" & TAB & "^Outliers", sheetNum)
		toWB.addColumns(TAB & Main.dataSize & TAB & fld.ValidN & TAB & (Main.dataSize - fld.ValidN) & TAB & ol.size, sheetNum)
		Main.track(sheetNum) = Main.track(sheetNum) + 1
		toWB.addSubtitle("Outliers < 1% or > 99%, they are included in the computation of summary statistics below.", sheetNum)
		Dim sb As StringBuilder: sb.initialize
		For Each s As String In ol
			sb.Append(TAB & s)
		Next
		toWB.addColumns(sb.toString, sheetNum)
	Else
		toWB.addColumns("^" & TAB & "^N" & TAB & "^Valid" & TAB & "^Missing", sheetNum)
		toWB.addColumns(TAB & Main.dataSize & TAB & fld.ValidN & TAB & (Main.dataSize - fld.ValidN), sheetNum)
	End If
End Sub

