﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=6.8
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Private fx As JFX
End Sub

Sub addPrincipalToWb (outLines As List) As String()
	Main.PCANum = Main.PCANum + 1
	Dim byvar As List: byvar.initialize
	Main.bycase.initialize
	Dim header As String = ""
	Dim propVar As String = ""
	Dim cumPropVar As String = ""
	For j = 0 To outLines.Size -1
		Dim s As String = outLines.Get(j)
		If s.IndexOf("Cases") > -1 Then
			header = TAB & tabDelim(outLines.Get(j+1))
			header = header.Replace("PC", "^.PCA" & Main.PCANum & "_")
			Dim k As Int = j + 2
			Dim x As String = outLines.Get(k)
			Do While x.IndexOf("Importance") = -1
				byvar.Add(tabDelim(x))
				k = k + 1
				x  = outLines.Get(k)
			Loop
			
			Dim tt As String = outLines.Get(k+3)
			tt = tt.Replace("Proportion of Variance", "Prop_Variance")
			propVar  = tabDelim(tt)
			tt = outLines.Get(k+4)
			tt = tt.Replace("Cumulative Proportion", "Cum_Prop_Variance")
			cumPropVar = tabDelim(tt)
		End If
		If s.IndexOf("Importance") > -1 Then
			Dim k As Int = j + 6
			Dim x As String = outLines.Get(k)
			Do While x.trim.length>0
				Main.bycase.Add(tabDelim(x))
				k = k + 1
				If k > outLines.size - 1 Then Exit
				x  = outLines.Get(k)
			Loop
			Exit
		End If
	Next
	addColumns(header, 3)
	For Each t As String In byvar
		addColumns("^" & t, 3)
	Next
	Main.track(3) = Main.track(3) + 1
	addColumns("^" & propVar, 3)
	addColumns("^" & cumPropVar, 3)
	Main.track(3) = Main.track(3) + 1
	addSubtitle("PCA scores for each case have been added to the dataset for this session", 3)
	Dim w() As String = Regex.Split(TAB, header)
	Return w
End Sub

Sub addRegressionToWb (outLines As List)
	Dim nextIndent As Boolean = False
	For Each s As String In outLines
		s = s.trim
		Dim ignore As Boolean = False
		If s.StartsWith("Call:") Or s.StartsWith("Signif. codes")  Or s.StartsWith("lm(formula") Or s.EndsWith("= RD)") Or s.IndexOf("Cases")>-1 Then ignore = True
		If ignore = False Then
			If s.StartsWith("Coefficients") And s.IndexOf("singularities")>-1 Then s = "Coefficients (NA = zero variance)"
			s = s.Replace("Pr(>|t|)", "Pr[>abs(t)]")
			s = s.Replace("---", "")
			s = s.Replace("," & TAB & "Adjusted", " Adj.")
			s = s.Replace("< ", "<")
				
			Dim skipParse As Boolean = False
			If s.IndexOf("Min")>-1 Then
				s = TAB & "^" & s
				nextIndent = True
			Else if nextIndent Then
				nextIndent = False
				s = TAB & s
			else if s.IndexOf("standard error")>-1 Then
				Dim er1 As String = s.SubString2(s.IndexOf(":") + 1, s.IndexOf(" on "))
				Dim df1 As String = s.SubString2(s.IndexOf(" on ") + 4, s.IndexOf(" degrees "))
				s = "Residual S.E. (" & df1 & ") = " & er1
				Main.track(3) = Main.track(3) + 1
				skipParse = True
			else if s.IndexOf("R-squared")>-1 Then
				Dim r2 As String = s.SubString2(s.IndexOf(":") + 2, s.IndexOf(" Adj"))
				Dim ar2 As String = s.SubString(s.IndexOf(" Adj") + 17)
				s = "R-Sq = " & r2 & "     Adjusted R-Sq = " & ar2
				skipParse = True
			else if s.IndexOf("F-statistic")>-1 Then
				If s.IndexOf("*") > -1 Then s = s.SubString2(0, s.IndexOf("*"))
				Dim f1 As String = s.SubString2(s.IndexOf(":") + 1, s.IndexOf(" on "))
				Dim df1 As String = s.SubString2(s.IndexOf(" on ") + 4, s.IndexOf(" and "))
				Dim df2 As String = s.SubString2(s.IndexOf(" and ") + 5, s.IndexOf(" DF,"))
				Dim pv1 As String = s.SubString(s.IndexOf(" p-value:") + 10)
				pv1 = pv1.Trim
				If pv1.StartsWith("<") Then pv1 = pv1.SubString(1)
				Dim pv2 As Float = pv1
				pv1 = NumberFormat2(pv1, 1, 4, 4, False)
				If pv2<.0001 Then
					pv1 = "<.0001 ***"
				else if pv2<.001 Then
					pv1 = pv1 & " ***"
				else if pv2<.01 Then
					pv1 = pv1 & " **"
				else if pv2<.05 Then
					pv1 = pv1 & " *"
				End If
				s = "F (" & df1 & "," & df2 & ") = " & f1 & "   p-value: " & pv1
				skipParse = True
			Else if s.StartsWith ("Coefficients") Then
				Main.track(3) = Main.track(3) + 1
				skipParse = True
			End If
			If skipParse = False Then
				Dim sb As StringBuilder: sb.initialize
				Dim sv() As String = Regex.Split("\ ", s)
				For j = 0 To sv.Length-1
					If sv(j)<>"" Then
						If sv(j).StartsWith("value") Or sv(j).StartsWith("Error") Then
							sb.remove(sb.Length-1, sb.Length)
							sb.Append(" " & sv(j) & TAB)
						else if sv(j).StartsWith(TAB) Then
							sb.append(sv(j) & TAB)
						Else if sv(j).StartsWith("<") Then
							sb.Append("^<0.0001" & TAB)
						Else if IsNumber(sv(j)) Then
							Dim pvx As Float = sv(j)
							sv(j) = NumberFormat2(pvx, 1, 4, 4, False)
							If pvx>0 Then
								If pvx<.0001 Then sv(j) = "^<0.0001"
							Else
								If pvx>.0001 Then sv(j) = "^~0.0000"
							End If
							sb.Append(sv(j) & TAB)
						Else
							sb.Append("^" & sv(j) & TAB)
						End If
					End If
				Next
				If sb.Length>0 Then
					sb.remove(sb.Length-1, sb.Length)
					Dim res As String = sb.toString
					If res.StartsWith("^Estimate") Then res = "^" & TAB & res
					If res.IndexOf(":")>-1 Or res.IndexOf("=")>-1 Then
						Main.track(3) = Main.track(3) + 1
						addSubtitle(res.SubString(1), 3)
					Else
						addColumns(res, 3)
					End If
				End If
			Else if s.Length>0 Then
				addSubtitle(s, 3)
			End If
		End If
	Next
End Sub

Sub addReliabilityToWb (outLines As List)
	Dim alpha As String = ""
	Dim rawAlpha As List: rawAlpha.initialize
	For j = 0 To outLines.Size -1
		Dim s As String = outLines.Get(j)
		If s.IndexOf("lower alpha upper") > -1 Then alpha = outLines.Get(j+1)
		If s.IndexOf("Reliability if") > -1 Then
			Dim k As Int = j + 2
			Dim x As String = outLines.Get(k)
			x = x.trim
			Do While x.Length>0
				rawAlpha.Add (x)
				k = k + 1
				x = outLines.Get(k)
				x = x .trim
			Loop
		End If
		If s.IndexOf("Item statistics") > -1 Then
			For k = 0 To rawAlpha.size - 1
				Dim x As String = outLines.Get(j + k + 2)
				x = x.trim
				rawAlpha.set (k, rawAlpha.get(k) & "   " & x)
			Next
		End If
	Next
	Dim res(5) As String
	
	Dim w() As String = Regex.Split(" ", alpha)
	addSubtitle("Cronbach's Alpha = " & w(1) & "       95% Confidence = [" & w(0) & ", " & w(2) &  "]", 3)
	Main.track(3) = Main.track(3) + 1
	addColumns(TAB & TAB & TAB & "^.R" & TAB & "^.Alpha", 3)
	addColumns(TAB & "^.Mean" & TAB & "^.S.D." & TAB & "^.if dropped" & TAB & "^.if dropped", 3)

	For Each s As String In rawAlpha
		Dim v() As String = Regex.Split(" ", s)
		Dim k As Int = 0
		For Each t As String In v
			If t.Length>0 Then
				k = k + 1
				If k = 1 Then res(0) = t
				If k = 16 Then res(1) = t
				If k = 17 Then res(2) = t
				If k = 15 Then res(3) = t
				If k = 2 Then res(4) = t
			End If
		Next
		addColumns("^" & res(0) & TAB & res(1) & TAB & res(2) & TAB & res(3) & TAB & res(4), 3)
	Next
End Sub

Sub tabDelim(s As String) As String
	Dim sb As StringBuilder: sb.initialize
	Dim v() As String = Regex.Split(" ", s)
	For Each t As String In v
		If t.Length>0 Then sb.Append(t & TAB)
	Next
	sb.Remove(sb.Length-1,sb.Length)
	Return sb.tostring
End Sub

Sub addCitation
	addTitle("All calculations for the tables on this 'multivariate' sheet were done by 'R'.", 3)
	addSubtitle("R Core Team (2013)", 3)
	addSubtitle("R: A language And environment For statistical computing.", 3)
	addSubtitle("R Foundation For Statistical Computing, Vienna, Austria.", 3)
	addSubtitle("http://www.R-project.org/", 3)
	Main.track(3) = Main.track(3) + 2
End Sub

Sub addTitle(s As String, sheetNum As Int)
	Main.track(sheetNum) = Main.track(sheetNum) + 1
	Dim row As PoiRow = Main.sheet(sheetNum).CreateRow(Main.track(sheetNum))
	Main.sheet(sheetNum).AddMergedRegion(0, Main.track(sheetNum) , 6, Main.track(sheetNum))
	Dim cellx As PoiCell = row.CreateCellString(0, s)
	cellx.CellStyle = Main.titleStyle
End Sub
	
Sub addSubtitle(s As String, sheetNum As Int)
	Main.track(sheetNum) = Main.track(sheetNum) + 1
	Dim row As PoiRow = Main.sheet(sheetNum).CreateRow(Main.track(sheetNum))
	Main.sheet(sheetNum).AddMergedRegion(1, Main.track(sheetNum) , 11, Main.track(sheetNum) )
	Dim cell As PoiCell
	If s.indexOf("http")>-1 Then
		cell = row.CreateCellFormula(1, $"=HYPERLINK("${s}","${s}")"$)
		cell.CellType = cell.TYPE_FORMULA
		cell.CellStyle = Main.urlStyle
	Else
		cell = row.CreateCellString(1, s)
		cell.CellStyle = Main.subTitleStyleLeft
	End If
End Sub

Sub addColumns(s As String, sheetNum As Int)
	Dim w() As String = Regex.Split("\|", s)
	Dim startat As Int = 0
	Main.track(sheetNum) = Main.track(sheetNum) + 1
	Dim aRow As PoiRow = Main.sheet(sheetNum).CreateRow(Main.track(sheetNum))
	
	For m = 0 To w.Length-1
		Dim v() As String = Regex.Split(TAB, w(m))
		For k = 0 To v.Length-1
			If v(k).Length>0 Then
				If v(k).StartsWith("^.") Then
					Dim vks As String = v(k).SubString(2).trim
					Dim cell As PoiCell = aRow.CreateCellString(startat+k, vks)
					cell.CellStyle = Main.subTitleStyleCenter
				else If v(k).StartsWith("^") Then
					Dim vks As String = v(k).SubString(1).trim
					If vks.Length>0 Then
						Dim cell As PoiCell = aRow.CreateCellString(startat+k, vks)
						If vks.StartsWith ("~") Or vks.StartsWith ("<") Then
							cell.CellStyle = Main.numStyle
						else If vks.StartsWith ("*") Then
							cell.CellStyle = Main.subTitleStyleLeft
						Else
							cell.CellStyle = Main.subTitleStyleRight
						End If
					End If
				else if v(k).indexOf(" ")>-1 Then
					Dim cell As PoiCell = aRow.CreateCellString(startat+k, v(k))
					cell.CellStyle = Main.subTitleStyleRight
				Else
					Try
						cell = aRow.CreateCellNumeric(startat+k, v(k))
						cell.CellStyle = Main.numStyle
					Catch
						Log(s)
					End Try
				End If
			End If
		Next
		startat = startat + v.Length + 3
	Next
End Sub

Sub addFrequencies(fld As field, sheetNum As Int)
	If fld.Frequencies.Size = 0 Then
		Main.track(sheetNum) = Main.track(sheetNum) + 1
	Else
		addColumns(TAB & "^n" & TAB & "^%", sheetNum)
		For Each fp As freqPair In fld.Frequencies
			Dim nam As String = fp.val
			Dim outlier As String = ""
			If fld.Outliers.Size>0 Then
				If fld.Outliers.IndexOf(nam)> -1 Then outlier = "!"
			End If
			If fld.Numeric Then nam = "'" & nam & "'"
			addColumns("^" & nam & TAB & fp.num & TAB & percent(fp.num, fld.ValidN) & TAB & TAB & "^" & outlier, sheetNum)
		Next
		Main.track(sheetNum) = Main.track(sheetNum) + 1
		Dim ol As List = fld.outliers
		If ol.size>0 Then
			addColumns("^" & TAB & "^N" & TAB & "^Valid" & TAB & "^Missing" & TAB & "^Outliers", sheetNum)
			addColumns(TAB & Main.dataSize & TAB & fld.ValidN & TAB & (Main.dataSize - fld.ValidN) & TAB & ol.size, sheetNum)
		Else
			addColumns("^" & TAB & "^N" & TAB & "^Valid" & TAB & "^Missing", sheetNum)
			addColumns(TAB & Main.dataSize & TAB & fld.ValidN & TAB & (Main.dataSize - fld.ValidN), sheetNum)
		End If
	End If
End Sub

Sub addShortFrequencies(fld As field, sheetNum As Int)
	addColumns(TAB & "^n", sheetNum)
	For Each fp As freqPair In fld.Frequencies
		Dim nam As String = fp.val
		If fld.Numeric Then nam = "'" & nam & "'"
		addColumns("^" & nam & TAB & fp.num, sheetNum)
	Next
	Main.track(sheetNum) = Main.track(sheetNum) + 1
	addColumns("^" & TAB & "^N" & TAB & "^Valid" & TAB & "^Missing", sheetNum)
	addColumns(TAB & Main.dataSize & TAB & fld.ValidN & TAB & (Main.dataSize - fld.ValidN), sheetNum)
End Sub

Sub percent (x As Int, n As Int) As String
	Dim r As Float = 100*x/n
	Return NumberFormat2(r, 1, 1, 1, False)
End Sub

Sub addDescriptives(fld As field, sheetNum As Int)
	If fld.Frequencies.Size = 0 Then Return
	
	Main.track(sheetNum) = Main.track(sheetNum) + 1
	Dim mean As String = NumberFormat2(fld.Mean, 1, 4, 4, False)
	Dim std As String = NumberFormat2(fld.SD, 1, 4, 4, False)
	Dim sem As String = NumberFormat2(fld.SEM, 1, 4, 4, False)
	Dim minx As String = NumberFormat2(fld.MinX, 1, 4, 4, False)
	Dim maxx As String = NumberFormat2(fld.MaxX, 1, 4, 4, False)
	addColumns("^" & TAB & "^Mean" & TAB & "^SD" & TAB & "^SEM" & TAB & "^Min" & TAB & "^Max", sheetNum)
	addColumns(TAB & mean & TAB & std & TAB & sem & TAB & minx & TAB & maxx, sheetNum)
	Main.track(sheetNum) = Main.track(sheetNum) + 1
End Sub


Sub errorNote (a As field, b As field)
	Dim dt As Long = DateTime.Now
	Dim dtx As String = DateTime.Date(dt) & " " & DateTime.Time(dt)
	addTitle(a.Name & " x " & b.Name & "   -   Breakdown      [" & dtx & "]", 2)
	addSubtitle("'" & b.Name & "' has too many distinct values for computing bivariate statistics" , 2)
	Main.track(2) = Main.track(2) + 1
End Sub

