﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=6.8
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Private fx As JFX
End Sub

Sub isDateField(x As String) As Boolean
	Dim v() As String = Regex.Split("-", x)
	If v.Length <> 3 Then v = Regex.Split("/", x)
	If v.Length <> 3 Then v = Regex.Split(" ", x)
	If v.Length <> 3 Then Return False
	Dim nn As Int =  0
	Dim i0, i1, i2 As Int
	If IsNumber(v(0)) Then
		nn = nn + 1
		i0 = v(0)
		If i0 > Main.trackDate(0) Then Main.trackDate(0) = i0
	End If
	If IsNumber(v(1)) Then
		nn = nn + 1
		i1 = v(1)
		If i1 > Main.trackDate(1) Then Main.trackDate(1) = i1
	End If
	If IsNumber(v(0)) Then
		nn = nn + 1
		i2 = v(2)
		If i2 > Main.trackDate(2) Then Main.trackDate(2) = i2
	End If
	If nn<2 Then Return False
	Return True
End Sub

Sub fieldDefaults(fld As field)
	Dim L1 As List: L1.initialize
	Dim L2 As List: L2.initialize
	Dim L3 As List: L3.initialize
	fld.Frequencies = L1
	fld.Outliers = L2
	fld.Data = L3
	fld.Numeric = True
	fld.isDate = False
	fld.Mean = 0
	fld.SD = 0
	fld.SEM = 0
	fld.MinX = 0
	fld.MaxX = 0
End Sub

Sub standardizeDateFields(j As Int)
	Main.trackDate = Array As Int (-99999, -99999, -99999)
	Dim dateField As Boolean = True
	Dim fldx As field = Main.fields.Get(j)
	Dim dat As List = fldx.data
	For i = 0 To Main.dataSize - 1
		Dim content As String = dat.Get(i)
		If content.Length>0 Then
			If isDateField (content) = False Then
				dateField = False
				Exit
			End If
		End If
	Next
	If dateField = False Then Return
	fldx.isDate = True
	For i = 0 To Main.dataSize - 1
		Dim content As String = dat.Get(i)
		If content.Length>0 Then
			Dim v() As String = Regex.Split("-", content)
			If v.Length <> 3 Then v = Regex.Split("/", content)
			If v.Length <> 3 Then v = Regex.Split(" ", content)
			Dim dayx, monthx, yearx As String
			Dim dayxPos(3) As Boolean
			monthx = ""
			For k = 0 To 2
				dayxPos(k) = True
				If Main.trackDate(k) > 31 Then
					yearx = v(k)
					dayxPos(k) = False
				End If
			Next
			For k = 0 To 2
				If Main.trackDate(k) < 0 Then
					monthx = convertMonth(v(k))
					dayxPos(k) = False
				End If
			Next
			If monthx = "" Then
				For k = 0 To 2
					If Main.trackDate(k) = 12 Then
						monthx = v(k)
						dayxPos(k) = False
					End If
				Next
			End If
			For k = 0 To 2
				If dayxPos(k) Then dayx = v(k)
			Next
			If yearx.Length > 0 And yearx.Length = 2 Then yearx = "19" & yearx
			If monthx.Length = 1 Then monthx = "0" & monthx
			If dayx.Length = 1 Then dayx = "0" & dayx
			dat.set(i, yearx & "-" & monthx & "-" & dayx)
		End If
	Next
End Sub

Sub removeQuotes(s As String) As String
	Dim r() As String = Regex.Split(Chr(34), s)
	Dim sb As StringBuilder
	sb.Initialize
	For i = 0 To r.Length-1
		If i Mod 2 = 1 Then
			Dim w As String = r(i).Replace(Main.theDelimeter, "__")
			sb.append(w)
		Else
			sb.append(r(i))
		End If
	Next
	Return sb.toString
End Sub

Sub convertMonth(x As String) As String
	Dim mths() As String = Array As String ("jan", "feb", "mar", "apr", "may", "jun", "jul", "aug", "sep", "oct", "nov", "dec")
	x = x. toLowercase
	For k = 0 To mths.Length - 1
		If x.startswith(mths(k)) Then
			Exit
		End If
	Next
	k = k + 1
	Return k
End Sub

Sub isMissing(x As String) As Boolean
	For Each m As String In Main.missingValues
		If m.StartsWith("*") Then
			If x.IndexOf(m.SubString(1))>-1 Then Return True
		Else
			If x = m Then Return True
		End If
	Next
	Return False
End Sub

'When R returns matrices with the number of columns greater then 5, the matrix output is split into groups
Sub collapse(rout As List) As List
	Dim collapsed As List: collapsed.initialize
	Dim routMap As Map: routMap.initialize
	For i = 0 To rout.size-1
		Dim theLine As String = rout.Get(i)
		If theLine.IndexOf("PC") > -1 Then
			theLine = "* " & theLine
			rout.Set(i, theLine)
		End If
		Dim v(0) As String = Regex.Split(" ", theLine)
		If v(0).Length>0 Then
			If routMap.ContainsKey(v(0)) Then
				Dim first As Int = routMap.Get(v(0))
				Dim firstocc As String = rout.Get(first)
				theLine = theLine.subString(theLine.IndexOf(" "))
				rout.Set(first, firstocc & " " & theLine)
				rout.Set(i, "")
			Else
				routMap.Put(v(0), i)
			End If
		End If
	Next
	Dim lastLine As String = "."
	For i = 0 To rout.size-1
		Dim theLine As String = rout.Get(i)
		If theLine.Length>0 Then
			If theLine.StartsWith("*") Then
				Dim w() As String = Regex.Split(" ", theLine)
				Dim headers As List: headers.initialize
				For Each s As String In w
					If s.Length>0 And s<>"*" Then
						If headers.indexOf(s) = -1 Then headers.Add(s)
					End If
				Next
				Dim sb As StringBuilder: sb.initialize
				For Each s As String In headers
					sb.Append(" " & s)
				Next
				collapsed.Add(sb.ToString)
			Else
				collapsed.Add(theLine)
			End If
		else If lastLine<>"" Then
			collapsed.Add("")
		End If
		lastLine = theLine
	Next
	Return collapsed
End Sub

Sub makeTransformTemplate
	Dim toutput As List: toutput.initialize
	For Each fld As field In Main.fields
		Dim freq As List = fld.Frequencies
		If fld.Frequencies.Size > 0 And fld.frequencies.size <= 50 Then
			toutput.Add(fld.name)
			For Each fp As freqPair In freq
				Dim outlier As String = ""
				If fld.Outliers.IndexOf(fp.val)>-1 Then outlier = "outlier "
				toutput.Add(fp.val & TAB & "(" & outlier & "n=" & fp.num & ") => " & fp.val)
			Next
			toutput.Add("")
		End If
	Next
	File.WriteList(Main.transformationDir, Main.currentDataset & "_transforms.txt", toutput)
End Sub

Sub postEditROutput(analysis As String, dep As Int, indepList As List, tnames As List)
	Dim outLines As List = File.ReadList(Main.RInvokeDir, "RMyScript.Rout")
	For j = 0 To outLines.Size - 1
		Dim s As String = outLines.Get(j)
		s = s.trim
		If s.IndexOf("v1") > -1 Then
			Dim startAt As Int = -1
			If analysis = "regression" Then startAt = 0
			For Each k As Int In indepList
				startAt = startAt + 1
				Dim nam As String = tnames.Get(startAt)
				Dim fld As field = Main.fields.Get(k)
				s = s.Replace (nam, fld.name)
			Next
		End If
		outLines.set(j, s)
	Next
	Dim dt As Long = DateTime.Now
	Dim dtx As String = DateTime.Date(dt) & " " & DateTime.Time(dt)
	
	Dim fld As field = Main.fields.Get(dep)
	Dim depName As String = fld.name
		
	If analysis ="regression" Then
		Main.track(3) = Main.track(3) + 1
		toWB.addTitle(depName & " as a linear function (n = " & (Main.rdata.Size-1) & ")      [" & dtx & "]", 3)
		toWB.addRegressionToWb (outLines)
	Else If analysis ="reliability" Then
		Main.track(3) = Main.track(3) + 1
		toWB.addTitle("Reliability Analysis (n = " & (Main.rdata.Size-1) & ")      [" & dtx & "]", 3)
		toWB.addSubtitle("This analysis is only relevant if items are intended to measure the same construct. Alpha > 0.70 is considered good.", 3)
		toWB.addReliabilityToWb (outLines)
	Else If analysis ="principal" Then
		Main.track(3) = Main.track(3) + 1
		toWB.addTitle("Principal Component Analysis (n = " & (Main.rdata.Size-1) & ")      [" & dtx & "]", 3)
		outLines = collapse(outLines)
	
		Dim w() As String = toWB.addPrincipalToWb (outLines)
		Dim pc(w.Length, Main.dataSize) As String
		For i = 0 To Main.bycase.Size -1
			Dim t As String = Main.bycase.Get(i)
			Dim k As Int = t.IndexOf(TAB)
			Dim caseNum As Int = Main.casesRef.Get(i)
			Dim v() As String = Regex.Split(TAB, t)
			For j = 1 To v.Length -1
				pc(j, caseNum) = v(j)
			Next
		Next

		If Main.filterVariable = -1 Then
			For j = 1 To w.Length - 1
				Dim newFld As field: newFld.initialize
				Dim nam As String = w(j).SubString(2)
				newFld.Name = nam
				fieldDefaults(newFld)
				Main.fieldMap.Put(newFld.Name, Main.numFields)
				Main.fields.Add(newFld)
				Main.numFields = Main.numFields + 1
				For i = 0 To Main.dataSize-1
					newFld.data.Add(pc(j, i))
				Next
				stats.summarizeNum(newFld)
			Next
		End If
	End If
End Sub

Sub twoParts(s As String, c As String) As String()
	Dim r(2) As String
	r(0) = s
	r(1) = ""
	Dim k As Int = s.indexOf(c)
	If k>-1 Then
		r(0) = s.SubString2(0, k)
		r(1) = s.SubString(k+c.length)
	End If
	Return r
End Sub

Sub stripQ (s As String) As String
	s = s.trim
	If s.StartsWith("'") = False Then Return s
	Return s.SubString2(1, s.Length-1)
End Sub